package learner;

import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import bsh.Interpreter;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Display implements Serializable{

  JFrame frame;
  JPanel textPanel;
  JPanel buttonPanel;
  JPanel panel;
  JSplitPane splitPane;
  JTextArea textArea;
  JToolBar toolBar;
  JTextArea codeArea;
  JTextArea outputArea;
  JScrollPane leftScrollPane;
  JScrollPane rightScrollPane;
  JButton sendButton;
  JButton connectButton;
  JButton closeConnectionButton;
  JButton listenButton;
  JMenuBar menuBar;
  JMenu fileMenu;
  JMenu connectionMenu;

  JMenuItem openFileItem;
  JMenuItem saveFileItem;
  JMenuItem exitFileItem;

  JMenuItem statsConnectionsItem;
  JMenuItem connectConnectionItem;
  JMenuItem disconnectConnectionItem;
  JToolBar jtb = new JToolBar();
  BufferedReader br;
  CodeMessage codeMessage;


 private Client client;
  Server server;
  Listener listener = new Listener(this);

  Display thisDisplay;
  public Display(String title) {
    thisDisplay = this;
    client = new Client(thisDisplay);
    //server = new Server(thisDisplay,client);
    frame = new JFrame(title);
    textPanel = new JPanel();
    buttonPanel = new JPanel();
    buttonPanel.setLayout(new GridLayout(1,0));
    textPanel.setLayout(new GridLayout(0,1));

    menuBar = new JMenuBar();
    fileMenu = new JMenu("File");
    connectionMenu = new JMenu("Connections");
    openFileItem = new JMenuItem("Open File");
    saveFileItem = new JMenuItem("Save File");
    exitFileItem = new JMenuItem("Exit");

    connectConnectionItem = new JMenuItem("Connect...");
    statsConnectionsItem = new JMenuItem("Current Connections");
    disconnectConnectionItem = new JMenuItem("Disconnect");

    fileMenu.add(openFileItem);
    fileMenu.add(saveFileItem);
    fileMenu.add(exitFileItem);
    connectionMenu.add(statsConnectionsItem);
    connectionMenu.add(connectConnectionItem);
    connectionMenu.add(disconnectConnectionItem);

    menuBar.add(fileMenu);
    menuBar.add(connectionMenu);

    frame.setJMenuBar(menuBar);

    sendButton = new JButton("Send");
    connectButton = new JButton("Connect");
    closeConnectionButton = new JButton("Disconnect");
    listenButton = new JButton("Listen");
    connectConnectionItem.addActionListener(
      new ActionListener(){
        public void actionPerformed( ActionEvent e){
          new ConnectDialog(thisDisplay);
        }
      });
    closeConnectionButton.addActionListener(
      new ActionListener(){
        public void actionPerformed( ActionEvent e){
          client.close();
        }
      });
    listenButton.addActionListener(
      new ActionListener(){
        public void actionPerformed( ActionEvent e){

          listener.start();

          frame.repaint();

        }
      });
    sendButton.addActionListener(
      new ActionListener(){
        public void actionPerformed( ActionEvent e){
          codeMessage = new CodeMessage();
          try{
            client.i.eval(codeArea.getText());
          }catch(bsh.EvalError bee){outputArea.setText(bee.getMessage());}
          codeMessage.setCodeString(codeArea.getText());
          client.sendMessageToAll(codeMessage);
          //client.sendCodeToAll(codeArea.getText());


        }
      });
    connectButton.addActionListener(
      new ActionListener(){
        public void actionPerformed( ActionEvent e){
          new ConnectDialog(thisDisplay);
          //server.setStreams(client.sock);
          //server.start();
          //outputArea.setText("Connected to server " + client.sock.getInetAddress());
        }
      });

    buttonPanel.add(connectButton);
    buttonPanel.add(closeConnectionButton);
    buttonPanel.add(sendButton);
    buttonPanel.add(listenButton);
    jtb.add(buttonPanel);
    outputArea = new JTextArea(20,15);
    codeArea = new JTextArea(20,15);
    //outputArea.setSize(150,90);
    outputArea.setEditable(true);
    codeArea.setEditable(true);

    outputArea.setLineWrap(true);
    codeArea.setLineWrap(true);

    leftScrollPane = new JScrollPane(outputArea);
    rightScrollPane = new JScrollPane(codeArea);

    leftScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    rightScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

    splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,leftScrollPane,rightScrollPane);
    splitPane.setDividerLocation(150);
    splitPane.setBorder(new BevelBorder(BevelBorder.RAISED));
    textPanel.add(splitPane);
    panel = new JPanel();
    panel.setLayout(new BorderLayout(2,1));

    panel.add(jtb, BorderLayout.CENTER);
    panel.add(textPanel, BorderLayout.SOUTH);

    frame.getContentPane().add(panel);
    frame.addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){System.exit(0);}
    });
    frame.pack();
    frame.setVisible(true);
    frame.repaint();
  }

  public Client getClient(){
   return this.client;
  }
  public Interpreter getInterpreter(){
   return client.i;
  }

  public static void main(String args[]){

    Display display = new Display("New teach thingy");

  }
}